diff --git a/lustre/autoconf/lustre-core.m4 b/lustre/autoconf/lustre-core.m4
index 822af2a..ab77548 100644
--- a/lustre/autoconf/lustre-core.m4
+++ b/lustre/autoconf/lustre-core.m4
@@ -1315,6 +1315,7 @@ LB_LINUX_TRY_COMPILE([
 	filldir_t filter;
 
 	filter = fillonedir;
+        filter(NULL, NULL, 0, 0, 0, 0);
 	return 1;
 ],[
         AC_MSG_RESULT(yes)
@@ -2174,6 +2175,152 @@ LB_LINUX_TRY_COMPILE([
 ])
 ])
 
+#
+# LC_SK_SLEEP_HELPER
+# 2.6.35 kernel has sk_sleep helper function
+#
+AC_DEFUN([LC_SK_SLEEP_HELPER],
+[AC_MSG_CHECKING([if kernel has sk_sleep helper])
+LB_LINUX_TRY_COMPILE([
+        #include <net/sock.h>
+],[
+        sk_sleep(NULL);
+],[
+        AC_MSG_RESULT(yes)
+        AC_DEFINE(HAVE_SK_SLEEP_HELPER, 1,
+                  [kernel has sk_sleep helper])
+],[
+        AC_MSG_RESULT(no)
+])
+])
+
+#
+# LC_DCACHE_LOCK
+# 2.6.38 introduces dcache RCU-walk
+#
+AC_DEFUN([LC_DCACHE_LOCK],
+[AC_MSG_CHECKING([if kernel has dcache_lock])
+LB_LINUX_TRY_COMPILE([
+        #include <linux/dcache.h>
+],[
+        spin_lock(&dcache_lock);
+],[
+        AC_MSG_RESULT(yes)
+        AC_DEFINE(HAVE_DCACHE_LOCK, 1,
+                  [kernel has dcache_lock])
+],[
+        AC_MSG_RESULT(no)
+])
+])
+
+#
+# LC_FS_STRUCT_SPINLOCK
+# 2.6.38 fs_struct.lock is spinlock
+#
+AC_DEFUN([LC_FS_STRUCT_SPINLOCK],
+[AC_MSG_CHECKING([if fs_struct.lock is spinlock])
+LB_LINUX_TRY_COMPILE([
+        #include <linux/fs_struct.h>
+],[
+        struct fs_struct fss;
+        spin_lock(&fss.lock);
+],[
+        AC_MSG_RESULT(yes)
+        AC_DEFINE(HAVE_FS_STRUCT_SPINLOCK, 1,
+                  [fs_struct.lock is spinlock])
+],[
+        AC_MSG_RESULT(no)
+])
+])
+
+#
+# LC_BLKDEV_GET_BY_DEV
+# 2.6.38 export blkdev_get_by_dev
+#
+AC_DEFUN([LC_BLKDEV_GET_BY_DEV],
+[LB_CHECK_SYMBOL_EXPORT([blkdev_get_by_dev],
+[fs/block_dev.c],[
+AC_DEFINE(HAVE_BLKDEV_GET_BY_DEV, 1,
+            [blkdev_get_by_dev is exported by the kernel])
+],[
+])
+])
+
+#
+# LC_CHECK_ACL_THREE_ARGS
+# 2.6.38 check_acl has three args
+#
+AC_DEFUN([LC_CHECK_ACL_THREE_ARGS],
+[AC_MSG_CHECKING([if check_acl has three args])
+LB_LINUX_TRY_COMPILE([
+        #include <linux/fs.h>
+],[
+        struct inode_operations iops;
+
+        iops.check_acl(NULL, 0, 0);
+],[
+        AC_MSG_RESULT(yes)
+        AC_DEFINE(HAVE_CHECK_ACL_THREE_ARGS, 1,
+                  [check_acl has three args])
+],[
+        AC_MSG_RESULT(no)
+])
+])
+
+#
+# LC_PERMISSION_FLAGS_ARG
+# 2.6.38 permission has flags argument
+#
+AC_DEFUN([LC_PERMISSION_FLAGS_ARG],
+[AC_MSG_CHECKING([if permission has flags argument])
+LB_LINUX_TRY_COMPILE([
+        #include <linux/fs.h>
+],[
+        struct inode_operations iops;
+
+        iops.permission(NULL, 1, 1);
+],[
+        AC_MSG_RESULT(yes)
+        AC_DEFINE(HAVE_PERMISSION_FLAGS_ARG, 1,
+                  [permission has flags argument])
+],[
+        AC_MSG_RESULT(no)
+])
+])
+
+#
+# LC_EXPORT_SIMPLE_SETATTR
+# 2.6.38 export simple_setattr
+#
+AC_DEFUN([LC_EXPORT_SIMPLE_SETATTR],
+[LB_CHECK_SYMBOL_EXPORT([simple_setattr],
+[fs/libfs.c],[
+AC_DEFINE(HAVE_SIMPLE_SETATTR, 1,
+            [simple_setattr is exported by the kernel])
+],[
+])
+])
+
+#
+# LC_EVICT_INODE
+# 2.6.38 evict_inode replaces delete_inode
+#
+AC_DEFUN([LC_EVICT_INODE],
+[AC_MSG_CHECKING([if evict_inode replaces delete_inode])
+LB_LINUX_TRY_COMPILE([
+        #include <linux/fs.h>
+],[
+        struct super_operations sops;
+
+        sops.evict_inode(NULL);
+],[
+        AC_MSG_RESULT(yes)
+        AC_DEFINE(HAVE_EVICT_INODE, 1,
+                  [evict_inode replaces delete_inode])
+],[
+        AC_MSG_RESULT(no)
+])
+])
 
 #
 # LC_PROG_LINUX
@@ -2330,6 +2477,18 @@ AC_DEFUN([LC_PROG_LINUX],
          LC_EXT4_SINGLEDATA_TRANS_BLOCKS_SB
          LC_WALK_SPACE_HAS_DATA_SEM
 
+         # 2.6.35
+         LC_SK_SLEEP_HELPER
+
+         # 2.6.38
+         LC_DCACHE_LOCK
+         LC_FS_STRUCT_SPINLOCK
+         LC_BLKDEV_GET_BY_DEV
+         LC_CHECK_ACL_THREE_ARGS
+         LC_PERMISSION_FLAGS_ARG
+         LC_EXPORT_SIMPLE_SETATTR
+         LC_EVICT_INODE
+
          #
          if test x$enable_server = xyes ; then
              AC_DEFINE(HAVE_SERVER_SUPPORT, 1, [support server])
diff --git a/lustre/fid/fid_store.c b/lustre/fid/fid_store.c
index 2226d5e..0525053 100644
--- a/lustre/fid/fid_store.c
+++ b/lustre/fid/fid_store.c
@@ -113,12 +113,10 @@ int seq_store_write(struct lu_server_seq *seq,
 {
         struct dt_object *dt_obj = seq->lss_obj;
         struct seq_thread_info *info;
-        struct dt_device *dt_dev;
         loff_t pos = 0;
         int rc;
         ENTRY;
 
-        dt_dev = lu2dt_dev(seq->lss_obj->do_lu.lo_dev);
         info = lu_context_key_get(&env->le_ctx, &seq_thread_key);
         LASSERT(info != NULL);
 
diff --git a/lustre/fld/fld_index.c b/lustre/fld/fld_index.c
index dd7b1de..997e781 100644
--- a/lustre/fld/fld_index.c
+++ b/lustre/fld/fld_index.c
@@ -153,7 +153,6 @@ int fld_index_create(struct lu_server_fld *fld,
                      struct thandle *th)
 {
         struct dt_object *dt_obj = fld->lsf_obj;
-        struct dt_device *dt_dev;
         seqno_t start;
         int rc;
 
@@ -161,7 +160,6 @@ int fld_index_create(struct lu_server_fld *fld,
 
         start = range->lsr_start;
         LASSERT(range_is_sane(range));
-        dt_dev = lu2dt_dev(fld->lsf_obj->do_lu.lo_dev);
 
         rc = dt_obj->do_index_ops->dio_insert(env, dt_obj,
                                               fld_rec(env, range),
@@ -189,13 +187,11 @@ int fld_index_delete(struct lu_server_fld *fld,
                      struct thandle   *th)
 {
         struct dt_object *dt_obj = fld->lsf_obj;
-        struct dt_device *dt_dev;
         seqno_t seq = range->lsr_start;
         int rc;
 
         ENTRY;
 
-        dt_dev = lu2dt_dev(fld->lsf_obj->do_lu.lo_dev);
         rc = dt_obj->do_index_ops->dio_delete(env, dt_obj,
                                               fld_key(env, seq), th,
                                               BYPASS_CAPA);
diff --git a/lustre/include/linux/lprocfs_status.h b/lustre/include/linux/lprocfs_status.h
index b9f52cc..43e730a 100644
--- a/lustre/include/linux/lprocfs_status.h
+++ b/lustre/include/linux/lprocfs_status.h
@@ -48,7 +48,12 @@
 
 #ifdef __KERNEL__
 #ifndef AUTOCONF_INCLUDED
-#include <linux/config.h>
+#  include <linux/version.h>
+#  if LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 37)
+#    include <generated/autoconf.h>
+#  else
+#    include <linux/config.h>
+#  endif
 #endif
 #include <linux/autoconf.h>
 #include <linux/proc_fs.h>
diff --git a/lustre/include/linux/lustre_compat25.h b/lustre/include/linux/lustre_compat25.h
index a1291c9..80e8fda 100644
--- a/lustre/include/linux/lustre_compat25.h
+++ b/lustre/include/linux/lustre_compat25.h
@@ -65,6 +65,14 @@ struct ll_iattr {
 #define ll_iattr iattr
 #endif /* LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,14) */
 
+#ifdef HAVE_FS_STRUCT_SPINLOCK
+#  define LOCK_FS_STRUCT(fs)   cfs_spin_lock(&(fs)->lock)
+#  define UNLOCK_FS_STRUCT(fs) cfs_spin_unlock(&(fs)->lock)
+#else
+#  define LOCK_FS_STRUCT(fs)   cfs_write_lock(&(fs)->lock)
+#  define UNLOCK_FS_STRUCT(fs) cfs_write_unlock(&(fs)->lock)
+#endif
+
 #ifdef HAVE_FS_STRUCT_USE_PATH
 static inline void ll_set_fs_pwd(struct fs_struct *fs, struct vfsmount *mnt,
                                  struct dentry *dentry)
@@ -74,11 +82,11 @@ static inline void ll_set_fs_pwd(struct fs_struct *fs, struct vfsmount *mnt,
 
         path.mnt = mnt;
         path.dentry = dentry;
-        write_lock(&fs->lock);
+        LOCK_FS_STRUCT(fs);
         old_pwd = fs->pwd;
         path_get(&path);
         fs->pwd = path;
-        write_unlock(&fs->lock);
+        UNLOCK_FS_STRUCT(fs);
 
         if (old_pwd.dentry)
                 path_put(&old_pwd);
@@ -92,12 +100,12 @@ static inline void ll_set_fs_pwd(struct fs_struct *fs, struct vfsmount *mnt,
         struct dentry *old_pwd;
         struct vfsmount *old_pwdmnt;
 
-        cfs_write_lock(&fs->lock);
+        LOCK_FS_STRUCT(fs);
         old_pwd = fs->pwd;
         old_pwdmnt = fs->pwdmnt;
         fs->pwdmnt = mntget(mnt);
         fs->pwd = dget(dentry);
-        cfs_write_unlock(&fs->lock);
+        UNLOCK_FS_STRUCT(fs);
 
         if (old_pwd) {
                 dput(old_pwd);
@@ -255,9 +263,15 @@ static inline int cfs_cleanup_group_info(void)
 
 #include <linux/proc_fs.h>
 
-#if !defined(HAVE_D_REHASH_COND) && defined(HAVE___D_REHASH)
-#define d_rehash_cond(dentry, lock) __d_rehash(dentry, lock)
-extern void __d_rehash(struct dentry *dentry, int lock);
+#ifdef HAVE_D_REHASH_COND
+#  define ll_d_rehash_cond(dentry, lock) d_rehash_cond(dentry, lock)
+#elif defined(HAVE___D_REHASH)
+#  define ll_d_rehash_cond(dentry, lock) __d_rehash(dentry, lock)
+   extern void __d_rehash(struct dentry *dentry, int lock);
+#endif
+
+#ifndef HAVE_DCACHE_LOCK
+#  define ll_d_rehash_cond(dentry, lock) d_rehash(dentry)
 #endif
 
 #ifdef HAVE_CAN_SLEEP_ARG
@@ -646,6 +660,7 @@ static inline int ll_crypto_hmac(struct crypto_tfm *tfm,
 #define ll_crypto_tfm_alg_max_keysize	crypto_tfm_alg_max_keysize
 #endif /* HAVE_ASYNC_BLOCK_CIPHER */
 
+#define HAVE_SYNCHRONIZE_RCU 1
 #ifndef HAVE_SYNCHRONIZE_RCU
 /* Linux 2.6.32 provides define when !CONFIG_TREE_PREEMPT_RCU */
 #ifndef synchronize_rcu
@@ -749,39 +764,14 @@ static inline long labs(long x)
 #define ll_sb_has_quota_active(sb, type) sb_has_quota_enabled(sb, type)
 #endif
 
-#ifdef HAVE_SB_ANY_QUOTA_ACTIVE
+#ifdef DQUOT_USAGE_ENABLED
+#define ll_sb_any_quota_active(sb) sb_any_quota_loaded(sb)
+#elif defined(HAVE_SB_ANY_QUOTA_ACTIVE)
 #define ll_sb_any_quota_active(sb) sb_any_quota_active(sb)
 #else
 #define ll_sb_any_quota_active(sb) sb_any_quota_enabled(sb)
 #endif
 
-static inline int
-ll_quota_on(struct super_block *sb, int off, int ver, char *name, int remount)
-{
-        if (sb->s_qcop->quota_on) {
-                return sb->s_qcop->quota_on(sb, off, ver, name
-#ifdef HAVE_QUOTA_ON_5ARGS
-                                            , remount
-#endif
-                                           );
-        }
-        else
-                return -ENOSYS;
-}
-
-static inline int ll_quota_off(struct super_block *sb, int off, int remount)
-{
-        if (sb->s_qcop->quota_off) {
-                return sb->s_qcop->quota_off(sb, off
-#ifdef HAVE_QUOTA_OFF_3ARGS
-                                             , remount
-#endif
-                                            );
-        }
-        else
-                return -ENOSYS;
-}
-
 #ifndef HAVE_BLK_QUEUE_LOG_BLK_SIZE /* added in 2.6.31 */
 #define blk_queue_logical_block_size(q, sz) blk_queue_hardsect_size(q, sz)
 #endif
@@ -837,5 +827,39 @@ static inline int ll_quota_off(struct super_block *sb, int off, int remount)
 #define bio_hw_segments(q, bio) 0
 #endif
 
+#ifdef HAVE_DCACHE_LOCK
+#define LOCK_DCACHE     cfs_spin_lock(&dcache_lock)
+#define UNLOCK_DCACHE   cfs_spin_unlock(&dcache_lock)
+#define LL_LOCK_DCACHE                                  \
+        do {                                            \
+                cfs_spin_lock(&ll_lookup_lock);         \
+                LOCK_DCACHE;                            \
+        } while (0)
+#define LL_UNLOCK_DCACHE                                \
+        do {                                            \
+                UNLOCK_DCACHE;                          \
+                cfs_spin_unlock(&ll_lookup_lock);       \
+        } while (0)
+#define dget_dlock(d)   dget_locked(d)
+#define d_refcount(d)   atomic_read(&(d)->d_count)
+#else
+#define LOCK_DCACHE      do {} while (0)
+#define UNLOCK_DCACHE    do {} while (0)
+#define LL_LOCK_DCACHE   do {} while (0)
+#define LL_UNLOCK_DCACHE do {} while (0)
+#define d_refcount(d)   ((d)->d_count)
+#endif
+
+#ifndef HAVE_BLKDEV_GET_BY_DEV
+#define blkdev_get_by_dev(dev, mode, holder) open_by_devnum(dev, mode)
+#endif
+
+#ifndef QUOTA_OK
+#define QUOTA_OK 0
+#endif
+#ifndef NO_QUOTA
+#define NO_QUOTA 1
+#endif
+
 #endif /* __KERNEL__ */
 #endif /* _COMPAT25_H */
diff --git a/lustre/include/linux/lustre_patchless_compat.h b/lustre/include/linux/lustre_patchless_compat.h
index 17fbc5c..8eedb3b 100644
--- a/lustre/include/linux/lustre_patchless_compat.h
+++ b/lustre/include/linux/lustre_patchless_compat.h
@@ -93,9 +93,10 @@ truncate_complete_page(struct address_space *mapping, struct page *page)
 }
 #endif /* HAVE_TRUNCATE_COMPLETE_PAGE */
 
-#if !defined(HAVE_D_REHASH_COND) && !defined(HAVE___D_REHASH)
+#if defined(HAVE_DCACHE_LOCK) && !defined(HAVE_D_REHASH_COND) && \
+   !defined(HAVE___D_REHASH)
 /* megahack */
-static inline void d_rehash_cond(struct dentry * entry, int lock)
+static inline void ll_d_rehash_cond(struct dentry * entry, int lock)
 {
 	if (!lock)
 		spin_unlock(&dcache_lock);
@@ -105,8 +106,6 @@ static inline void d_rehash_cond(struct dentry * entry, int lock)
 	if (!lock)
 		spin_lock(&dcache_lock);
 }
-
-#define __d_rehash(dentry, lock) d_rehash_cond(dentry, lock)
 #endif /* !HAVE_D_REHASH_COND && !HAVE___D_REHASH*/
 
 #ifdef ATTR_OPEN
diff --git a/lustre/include/linux/lvfs.h b/lustre/include/linux/lvfs.h
index 020e039..9004058 100644
--- a/lustre/include/linux/lvfs.h
+++ b/lustre/include/linux/lvfs.h
@@ -113,7 +113,7 @@ static inline void l_dput(struct dentry *de)
         if (!de || IS_ERR(de))
                 return;
         //shrink_dcache_parent(de);
-        LASSERT(cfs_atomic_read(&de->d_count) > 0);
+        LASSERT(d_refcount(de) > 0);
         dput(de);
 }
 
diff --git a/lustre/include/linux/obd_support.h b/lustre/include/linux/obd_support.h
index beae348..ef5a5b9 100644
--- a/lustre/include/linux/obd_support.h
+++ b/lustre/include/linux/obd_support.h
@@ -43,7 +43,12 @@
 
 #ifdef __KERNEL__
 #ifndef AUTOCONF_INCLUDED
-#include <linux/config.h>
+#  include <linux/version.h>
+#  if LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 37)
+#    include <generated/autoconf.h>
+#  else
+#    include <linux/config.h>
+#  endif
 #endif
 #include <linux/seq_file.h>
 #include <linux/module.h>
diff --git a/lustre/ldlm/ldlm_flock.c b/lustre/ldlm/ldlm_flock.c
index 55117d1..46c5e05 100644
--- a/lustre/ldlm/ldlm_flock.c
+++ b/lustre/ldlm/ldlm_flock.c
@@ -650,14 +650,11 @@ EXPORT_SYMBOL(ldlm_flock_completion_ast);
 int ldlm_flock_blocking_ast(struct ldlm_lock *lock, struct ldlm_lock_desc *desc,
                             void *data, int flag)
 {
-        struct ldlm_namespace *ns;
         ENTRY;
 
         LASSERT(lock);
         LASSERT(flag == LDLM_CB_CANCELING);
 
-        ns = ldlm_lock_to_ns(lock);
-
         /* take lock off the deadlock detection waitq. */
         cfs_spin_lock(&ldlm_flock_waitq_lock);
         cfs_list_del_init(&lock->l_flock_waitq);
diff --git a/lustre/ldlm/ldlm_lib.c b/lustre/ldlm/ldlm_lib.c
index e2b0410..a344aef 100644
--- a/lustre/ldlm/ldlm_lib.c
+++ b/lustre/ldlm/ldlm_lib.c
@@ -2129,7 +2129,6 @@ void target_send_reply(struct ptlrpc_request *req, int rc, int fail_id)
 {
         int                        netrc;
         struct ptlrpc_reply_state *rs;
-        struct obd_device         *obd;
         struct obd_export         *exp;
         struct ptlrpc_service     *svc;
         ENTRY;
@@ -2163,7 +2162,6 @@ void target_send_reply(struct ptlrpc_request *req, int rc, int fail_id)
         LASSERT (cfs_list_empty(&rs->rs_exp_list));
 
         exp = class_export_get (req->rq_export);
-        obd = exp->exp_obd;
 
         /* disable reply scheduling while I'm setting up */
         rs->rs_scheduled = 1;
diff --git a/lustre/ldlm/ldlm_lockd.c b/lustre/ldlm/ldlm_lockd.c
index 6234ccf..dff0c57 100644
--- a/lustre/ldlm/ldlm_lockd.c
+++ b/lustre/ldlm/ldlm_lockd.c
@@ -276,7 +276,7 @@ static int ldlm_lock_busy(struct ldlm_lock *lock)
 /* This is called from within a timer interrupt and cannot schedule */
 static void waiting_locks_callback(unsigned long unused)
 {
-        struct ldlm_lock *lock, *last = NULL;
+        struct ldlm_lock *lock;
 
 repeat:
         cfs_spin_lock_bh(&waiting_locks_spinlock);
@@ -352,8 +352,6 @@ repeat:
                            libcfs_nid2str(
                                    lock->l_export->exp_connection->c_peer.nid));
 
-                last = lock;
-
                 /* no needs to take an extra ref on the lock since it was in
                  * the waiting_locks_list and ldlm_add_waiting_lock()
                  * already grabbed a ref */
diff --git a/lustre/ldlm/ldlm_request.c b/lustre/ldlm/ldlm_request.c
index 767ca01..9a14654 100644
--- a/lustre/ldlm/ldlm_request.c
+++ b/lustre/ldlm/ldlm_request.c
@@ -700,7 +700,7 @@ int ldlm_prep_elc_req(struct obd_export *exp, struct ptlrpc_request *req,
         struct ldlm_namespace   *ns = exp->exp_obd->obd_namespace;
         struct req_capsule      *pill = &req->rq_pill;
         struct ldlm_request     *dlm = NULL;
-        int flags, avail, to_free, bufcount, pack = 0;
+        int flags, avail, to_free, pack = 0;
         CFS_LIST_HEAD(head);
         int rc;
         ENTRY;
@@ -709,7 +709,6 @@ int ldlm_prep_elc_req(struct obd_export *exp, struct ptlrpc_request *req,
                 cancels = &head;
         if (exp_connect_cancelset(exp)) {
                 /* Estimate the amount of available space in the request. */
-                bufcount = req_capsule_filled_sizes(pill, RCL_CLIENT);
                 avail = ldlm_capsule_handles_avail(pill, RCL_CLIENT, canceloff);
 
                 flags = ns_connect_lru_resize(ns) ?
@@ -1115,8 +1114,6 @@ int ldlm_cli_cancel_req(struct obd_export *exp, cfs_list_t *cancels,
                 count = free;
 
         while (1) {
-                int bufcount;
-
                 imp = class_exp2cliimp(exp);
                 if (imp == NULL || imp->imp_invalid) {
                         CDEBUG(D_DLMTRACE,
@@ -1128,7 +1125,6 @@ int ldlm_cli_cancel_req(struct obd_export *exp, cfs_list_t *cancels,
                 if (req == NULL)
                         GOTO(out, rc = -ENOMEM);
 
-                bufcount = req_capsule_filled_sizes(&req->rq_pill, RCL_CLIENT);
                 req_capsule_set_size(&req->rq_pill, &RMF_DLM_REQ, RCL_CLIENT,
                                      ldlm_request_bufsize(count, LDLM_CANCEL));
 
@@ -1191,7 +1187,7 @@ static inline struct ldlm_pool *ldlm_imp2pl(struct obd_import *imp)
 int ldlm_cli_update_pool(struct ptlrpc_request *req)
 {
         struct obd_device *obd;
-        __u64 old_slv, new_slv;
+        __u64 new_slv;
         __u32 new_limit;
         ENTRY;
         if (unlikely(!req->rq_import || !req->rq_import->imp_obd ||
@@ -1231,7 +1227,6 @@ int ldlm_cli_update_pool(struct ptlrpc_request *req)
          * oops in that time.
          */
         cfs_write_lock(&obd->obd_pool_lock);
-        old_slv = obd->obd_pool_slv;
         obd->obd_pool_slv = new_slv;
         obd->obd_pool_limit = new_limit;
         cfs_write_unlock(&obd->obd_pool_lock);
diff --git a/lustre/llite/dcache.c b/lustre/llite/dcache.c
index 3f202c9..9136e01 100644
--- a/lustre/llite/dcache.c
+++ b/lustre/llite/dcache.c
@@ -82,24 +82,35 @@ static void ll_release(struct dentry *de)
  * an AST before calling d_revalidate_it().  The dentry still exists (marked
  * INVALID) so d_lookup() matches it, but we have no lock on it (so
  * lock_match() fails) and we spin around real_lookup(). */
+#if 1
+int ll_dcompare(const struct dentry *parent, const struct inode *pinode,
+                const struct dentry *dentry, const struct inode *inode,
+                unsigned int len, const char *str, const struct qstr *d_name)
+#else
 int ll_dcompare(struct dentry *parent, struct qstr *d_name, struct qstr *name)
+#endif
 {
         struct dentry *dchild;
         ENTRY;
 
+#if 0
         if (d_name->len != name->len)
                 RETURN(1);
 
         if (memcmp(d_name->name, name->name, name->len))
                 RETURN(1);
+#else
+        if (memcmp(d_name->name, str, d_name->len))
+                RETURN(1);
+#endif
 
         /* XXX: d_name must be in-dentry structure */
         dchild = container_of(d_name, struct dentry, d_name); /* ugh */
 
         CDEBUG(D_DENTRY,"found name %.*s(%p) - flags %d/%x - refc %d\n",
-               name->len, name->name, dchild,
+               d_name->len, d_name->name, dchild,
                d_mountpoint(dchild), dchild->d_flags & DCACHE_LUSTRE_INVALID,
-               atomic_read(&dchild->d_count));
+               d_refcount(dchild));
 
          /* mountpoint is always valid */
         if (d_mountpoint(dchild))
@@ -149,7 +160,7 @@ static int find_cbdata(struct inode *inode)
  * - return 0 to cache the dentry
  * Should NOT be called with the dcache lock, see fs/dcache.c
  */
-static int ll_ddelete(struct dentry *de)
+static int ll_ddelete(const struct dentry *de)
 {
         ENTRY;
         LASSERT(de);
@@ -157,12 +168,12 @@ static int ll_ddelete(struct dentry *de)
         CDEBUG(D_DENTRY, "%s dentry %.*s (%p, parent %p, inode %p) %s%s\n",
                (de->d_flags & DCACHE_LUSTRE_INVALID ? "deleting" : "keeping"),
                de->d_name.len, de->d_name.name, de, de->d_parent, de->d_inode,
-               d_unhashed(de) ? "" : "hashed,",
+               d_unhashed((struct dentry *)de) ? "" : "hashed,",
                list_empty(&de->d_subdirs) ? "" : "subdirs");
 
         /* if not ldlm lock for this inode, set i_nlink to 0 so that
          * this inode can be recycled later b=20433 */
-        LASSERT(atomic_read(&de->d_count) == 0);
+        LASSERT(d_refcount(de) == 0);
         if (de->d_inode && !find_cbdata(de->d_inode))
                 de->d_inode->i_nlink = 0;
 
@@ -179,7 +190,7 @@ static int ll_set_dd(struct dentry *de)
 
         CDEBUG(D_DENTRY, "ldd on dentry %.*s (%p) parent %p inode %p refc %d\n",
                de->d_name.len, de->d_name.name, de, de->d_parent, de->d_inode,
-               atomic_read(&de->d_count));
+               d_refcount(de));
 
         if (de->d_fsdata == NULL) {
                 struct ll_dentry_data *lld;
@@ -262,19 +273,17 @@ void ll_intent_release(struct lookup_intent *it)
 int ll_drop_dentry(struct dentry *dentry)
 {
         lock_dentry(dentry);
-        if (atomic_read(&dentry->d_count) == 0) {
+        if (d_refcount(dentry) == 0) {
                 CDEBUG(D_DENTRY, "deleting dentry %.*s (%p) parent %p "
                        "inode %p\n", dentry->d_name.len,
                        dentry->d_name.name, dentry, dentry->d_parent,
                        dentry->d_inode);
-                dget_locked(dentry);
+                dget_dlock(dentry);
                 __d_drop(dentry);
                 unlock_dentry(dentry);
-                spin_unlock(&dcache_lock);
-                cfs_spin_unlock(&ll_lookup_lock);
+                LL_UNLOCK_DCACHE;
                 dput(dentry);
-                cfs_spin_lock(&ll_lookup_lock);
-                spin_lock(&dcache_lock);
+                LL_LOCK_DCACHE;
                 return 1;
         }
         /* disconected dentry can not be find without lookup, because we
@@ -288,7 +297,7 @@ int ll_drop_dentry(struct dentry *dentry)
                 CDEBUG(D_DENTRY, "unhashing dentry %.*s (%p) parent %p "
                        "inode %p refc %d\n", dentry->d_name.len,
                        dentry->d_name.name, dentry, dentry->d_parent,
-                       dentry->d_inode, atomic_read(&dentry->d_count));
+                       dentry->d_inode, d_refcount(dentry));
                 /* actually we don't unhash the dentry, rather just
                  * mark it inaccessible for to __d_lookup(). otherwise
                  * sys_getcwd() could return -ENOENT -bzzz */
@@ -314,8 +323,10 @@ void ll_unhash_aliases(struct inode *inode)
                inode->i_ino, inode->i_generation, inode);
 
         head = &inode->i_dentry;
-        cfs_spin_lock(&ll_lookup_lock);
-        spin_lock(&dcache_lock);
+        LL_LOCK_DCACHE;
+#ifndef HAVE_DCACHE_LOCK
+        cfs_spin_lock(&inode->i_lock);
+#endif
 restart:
         tmp = head;
         while ((tmp = tmp->next) != head) {
@@ -336,8 +347,10 @@ restart:
                 if (ll_drop_dentry(dentry))
                           goto restart;
         }
-        spin_unlock(&dcache_lock);
-        cfs_spin_unlock(&ll_lookup_lock);
+#ifndef HAVE_DCACHE_LOCK
+        cfs_spin_unlock(&inode->i_lock);
+#endif
+        LL_UNLOCK_DCACHE;
 
         EXIT;
 }
@@ -455,7 +468,7 @@ int ll_revalidate_it(struct dentry *de, int lookup_flags,
                 struct inode *inode = de->d_inode;
                 struct ll_inode_info *lli = ll_i2info(inode);
                 struct obd_client_handle **och_p;
-                __u64 *och_usecount;
+/*                __u64 *och_usecount; */
 
                 /*
                  * We used to check for MDS_INODELOCK_OPEN here, but in fact
@@ -470,13 +483,13 @@ int ll_revalidate_it(struct dentry *de, int lookup_flags,
 
                 if (it->it_flags & FMODE_WRITE) {
                         och_p = &lli->lli_mds_write_och;
-                        och_usecount = &lli->lli_open_fd_write_count;
+/*                        och_usecount = &lli->lli_open_fd_write_count; */
                 } else if (it->it_flags & FMODE_EXEC) {
                         och_p = &lli->lli_mds_exec_och;
-                        och_usecount = &lli->lli_open_fd_exec_count;
+/*                        och_usecount = &lli->lli_open_fd_exec_count; */
                 } else {
                         och_p = &lli->lli_mds_read_och;
-                        och_usecount = &lli->lli_open_fd_read_count;
+/*                        och_usecount = &lli->lli_open_fd_read_count; */
                 }
                 /* Check for the proper lock. */
                 if (!ll_have_md_lock(inode, MDS_INODELOCK_LOOKUP, LCK_MINMODE))
@@ -552,14 +565,12 @@ revalidate_finish:
 
         /* unfortunately ll_intent_lock may cause a callback and revoke our
          * dentry */
-        cfs_spin_lock(&ll_lookup_lock);
-        spin_lock(&dcache_lock);
+        LL_LOCK_DCACHE;
         lock_dentry(de);
         __d_drop(de);
         unlock_dentry(de);
-        d_rehash_cond(de, 0);
-        spin_unlock(&dcache_lock);
-        cfs_spin_unlock(&ll_lookup_lock);
+        ll_d_rehash_cond(de, 0);
+        LL_UNLOCK_DCACHE;
 
 out:
         /* We do not free request as it may be reused during following lookup
@@ -576,7 +587,7 @@ out:
                 CDEBUG(D_DENTRY, "revalidated dentry %.*s (%p) parent %p "
                        "inode %p refc %d\n", de->d_name.len,
                        de->d_name.name, de, de->d_parent, de->d_inode,
-                       atomic_read(&de->d_count));
+                       d_refcount(de));
                 if (de->d_flags & DCACHE_LUSTRE_INVALID) {
                         lock_dentry(de);
                         de->d_flags &= ~DCACHE_LUSTRE_INVALID;
diff --git a/lustre/llite/dir.c b/lustre/llite/dir.c
index ff0e92d..178c504 100644
--- a/lustre/llite/dir.c
+++ b/lustre/llite/dir.c
@@ -57,6 +57,8 @@
 #include <lustre_fid.h>
 #include "llite_internal.h"
 
+#define HAVE_PAGE_CHECKED 1
+
 #ifndef HAVE_PAGE_CHECKED
 #ifdef HAVE_PG_FS_MISC
 #define PageChecked(page)        test_bit(PG_fs_misc, &(page)->flags)
@@ -451,7 +453,6 @@ int ll_readdir(struct file *filp, void *cookie, filldir_t filldir)
         struct page          *page;
         struct ll_dir_chain   chain;
         int                   done;
-        int                   shift;
         int                   rc;
         ENTRY;
 
@@ -467,7 +468,6 @@ int ll_readdir(struct file *filp, void *cookie, filldir_t filldir)
 
         rc    = 0;
         done  = 0;
-        shift = 0;
         ll_dir_chain_init(&chain);
 
         fd->fd_dir.lfd_next = pos;
@@ -825,9 +825,14 @@ static int copy_and_ioctl(int cmd, struct obd_export *exp, void *data, int len)
         return rc;
 }
 
-static int ll_dir_ioctl(struct inode *inode, struct file *file,
+#ifdef HAVE_COMPAT_IOCTL
+static long ll_dir_ioctl(struct file *file, unsigned int cmd, unsigned long arg)
+#else
+static int ll_dir_ioctl(struct inode *unused, struct file *file,
                         unsigned int cmd, unsigned long arg)
+#endif
 {
+        struct inode *inode = file->f_dentry->d_inode;
         struct ll_sb_info *sbi = ll_i2sbi(inode);
         struct obd_ioctl_data *data;
         int rc = 0;
@@ -1448,5 +1453,9 @@ struct file_operations ll_dir_operations = {
         .release  = ll_dir_release,
         .read     = generic_read_dir,
         .readdir  = ll_readdir,
+#ifdef HAVE_COMPAT_IOCTL
+        .compat_ioctl    = ll_dir_ioctl
+#else
         .ioctl    = ll_dir_ioctl
+#endif
 };
